--------------------------------------------------------------------------------
-- Alloy4PV -- Alloy for Process Verification
-- Copyright (C) 2012, 2014  Yoann Laurent (yoann.laurent@lip6.fr)

-- This program is free software: you can redistribute it and/or
-- modify it under the terms of the GNU General Public License as
-- published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version.

-- This program is distributed in the hope that it will be useful, but
-- WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see
-- <http://www.gnu.org/licenses/>.
--------------------------------------------------------------------------------

module process

open OrderProcess_t


/* ------------------------ Time  ------------------------*/
pred TimeBelow[maxTime:Int] {
	some s:State, f:ActivityFinalNode | s.hasTokens[f] and s.globalClock.gt[maxTime]
}
/* ------------------------ Business ------------------------*/
pred Business1[a,b:Action,maxTime:Int] {
	all s:State | s.hasTokens[a] implies {
		some ss:(s+s.^next) | ss.hasTokens[b] and ss.globalClock.minus[s.globalClock].lte[maxTime]
	}
}

check {TimeBelow[4]} for 0 but 38 State, 5 Int expect 1
check {Business1[FillOrder, SendInvoice, 6]} for 0 but 38 State, 5 Int expect 0


/** *Visualization Variables */
// http://alloy.mit.edu/community/node/548
fun vNodeExecuting : State->ActivityNode {
   {s:State, a:ActivityNode | s.hasTokens[a] }
}
fun vEdgeHaveOffers : State->ActivityEdge {
   {s:State, e:ActivityEdge | s.hasOffers[e] }
}
